const CracoLessPlugin = require('craco-less');
const CracoAlias = require("craco-alias");

module.exports = {
  plugins: [
    {
      plugin: CracoLessPlugin,
      options: {
        lessLoaderOptions: {
          lessOptions: {
            javascriptEnabled: true,
          },
        },
      },
    },
    {
      plugin: CracoAlias,
      options: {
        source: 'tsconfig',
        baseUrl: "./src",
        tsConfigPath: "./tsconfig.extend.json",
        debug: false,
      }
    }
  ],
  babel: {
    plugins: [
      ['import', { libraryName: 'antd', "libraryDirectory": "es", style: true }],
      ['@babel/plugin-proposal-decorators', { legacy: true }],
      [
        "styless",
        {
            "import": "~antd/lib/style/themes/default.less",
            "lessOptions": {
                "javascriptEnabled": true
            }
        }
      ],
    ]
  },
};