import React from 'react';
import { Button } from 'antd';
import { YDateFormat, YFilter, YFilterComponent, YSelect, YTable } from '@ywfe/ywd';
import { BtnGroupStyle } from './styles';

const Home: React.FC = () => {

  const filterConfig = [
    {
      type: YFilterComponent.Input,
      apiParam: 'name',
      label: '公司名称',
      originalProps: {
        placeholder: '请输入公司名称',
      },
    },
    {
      type: YFilterComponent.DatePickerRangePicker,
      apiParam: 'createTime',
      label: '申请时间',
      originalProps: {
        placeholder: ['开始时间', '结束时间'],
        format: YDateFormat.YYYY_MM_DD,
      },
    },
    {
      type: YFilterComponent.Input,
      apiParam: 'itemManager',
      label: '负责人',
      originalProps: {
        placeholder: '请输入负责人',
      },
    },
    {
      type: YFilterComponent.Input,
      apiParam: 'mainBrand',
      label: '主营品牌',
      originalProps: {
        placeholder: '请输入主营品牌',
      },
    },
  ];

  const filterTabs = {
    apiParam: 'speed',
    activeIndex: 0,
    options: [
      {
        label: '全部',
        value: '0',
      },
      {
        label: '待接入',
        value: '1',
      },
      {
        label: '未接入',
        value: '3',
      },
      {
        label: '谈恰中',
        value: '2',
      },
      {
        label: '已接入',
        value: '4',
      },
    ],
    tabBarExtraContent: (params: any) => (
      <BtnGroupStyle>
        <Button type="primary">
          导出
        </Button>
      </BtnGroupStyle>
    ),
  };

  const tableRecord = [
    {
      title: '公司名称',
      dataIndex: 'name',
      width: 300,
    },
    {
      title: '主营类目',
      dataIndex: 'type',
    },
    {
      title: '主营品牌',
      dataIndex: 'mainBrand',
    },
    {
      title: '操作人',
      dataIndex: 'adminName',
    },
    {
      title: '状态',
      dataIndex: 'speedName',
    },
    {
      title: '申请时间',
      dataIndex: 'createTime',
    },
    {
      title: '操作时间',
      dataIndex: 'auditTime',
    },
    {
      title: '备注',
      dataIndex: 'context',
    },
    {
      title: '操作',
      dataIndex: 'id',
      render: (_text: string, record: any) => <Edit record={record} supplyListReload={supplyListReload}/>,
    },
  ];

  return (
    <YFilter
      onReload={(reload: any) => {
        supplyListReload = false;
      }}
      config={filterConfig as any}
      request={null}
      tabs={filterTabs}
    >
      <YTable rowKey="id" columns={tableRecord}/>
    </YFilter>
  );
};

export default Home;
