import React, { lazy } from 'react';
import { YLoader, YRouterConfig } from '@ywfe/ywd';
import { configs } from '../generated/config';

const InAudit = lazy(() => import('../pages/supplyManage/inAudit/index'));

const token = localStorage.getItem('token');
const projectId = '<%= projectId %>';
const env = process.env.REACT_APP_ENV === 'production' ? 'prod' : localStorage.getItem('env') || 'debug';
const baseUrl = configs[projectId][env].APPLICATION_URL;

export const routerConfig: YRouterConfig = {
  // 有子菜单
  supplyManage: {
    icon: 'IdcardOutlined',
  },
  // 子菜单
  'supplyManage/inAudit': {
    component: () => (
      <YLoader>
        <InAudit />
      </YLoader>
    ),
  },
  // 老应用
  'supplyManage/checkAudit': {
    url: `${baseUrl}/supplyManage/checkAudit?token=${token}`,
    hidden: true,
  },
};
