"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pack = void 0;
const core_1 = require("@angular-devkit/core");
const schematics_1 = require("@angular-devkit/schematics");
function pack() {
    return (tree, context) => {
        const packagePath = `package.json`;
        const data = tree.read(packagePath);
        const pkg = JSON.parse(data.toString());
        const { name = '', dependencies } = pkg;
        const umdName = name.replace('yw-', '');
        const options = {
            umdName,
            name,
            exts: Object.keys(dependencies) || []
        };
        return schematics_1.branchAndMerge(schematics_1.chain([
            cleanPath(('/')),
            schematics_1.mergeWith(generate(options, '/')),
        ]))(tree, context);
    };
}
exports.pack = pack;
const cleanPath = (filePath) => {
    return (tree) => {
        try {
            if (tree.exists(`${filePath}/.DS_Store`)) {
                tree.delete(`${filePath}/.DS_Store`);
            }
        }
        catch (error) {
            console.error('cleanPath Error', error);
        }
        return tree;
    };
};
function generate(options, path) {
    return schematics_1.apply(schematics_1.url('./files'), [
        schematics_1.template(Object.assign(Object.assign({}, core_1.strings), options)),
        schematics_1.move(path),
    ]);
}
