"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RoutersFinder = void 0;
const core_1 = require("@angular-devkit/core");
class RoutersFinder {
    constructor(tree) {
        this.tree = tree;
    }
    find(options) {
        const generatedDirectoryPath = options.path;
        const generatedDirectory = this.tree.getDir(generatedDirectoryPath);
        return this.findIn(generatedDirectory);
    }
    findIn(directory) {
        if (!directory) {
            return null;
        }
        console.log('directory.subfiles', directory, directory.subfiles);
        const moduleFilename = directory.subfiles.find(filename => {
            console.log('filename', filename);
            return /\.index\.(t|j)s$/.test(filename);
        });
        return moduleFilename !== undefined
            ? core_1.join(directory.path, moduleFilename.valueOf())
            : this.findIn(directory.parent);
    }
}
exports.RoutersFinder = RoutersFinder;
